#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const ll MAX_N = 4e3 + 10;
bool ok[MAX_N][MAX_N];
ll n, m;

ll who[MAX_N];

ll comb[MAX_N][MAX_N];

ll dp[MAX_N][MAX_N];

ll solve(ll x) {
    for(ll i = 0; i <= m; i ++) {
        who[i] = 0;
    }
    for(ll i = 0; i <= m + 1; i ++) {
        for(ll j = 0; j <= n; j ++) {
            dp[i][j] = 0;
        }
    }

    for(ll i = 0; i < n; i ++) {
        if(i == x) { continue; }
        ll when = m;
        for(ll j = 0; j < m; j ++) {
            if(ok[x][j] != ok[i][j]) {
                when = j;
                break;
            }
        }
        who[when] ++;
    }

    ll sum = who[m] + 1;
    for(ll i = 0; i <= who[m] + 1; i ++) {
        dp[0][i + 1] = comb[sum - 1][i];
    }
    for(ll i = 0; i < m; i ++) {
        ll group = who[m - 1 - i];
        for(ll j = 0; j <= sum; j ++) {
            for(ll nw = 0; nw <= group && nw <= j; nw ++) {
                if(!ok[x][m - 1 - i] && nw == j) { continue; }
                dp[i + 1][j + nw] += (comb[group][nw] * dp[i][j]) % mod;
                dp[i + 1][j + nw] %= mod;
            }
        }

        sum += group;
    }

    ll ret = 0;
    for(ll i = 0; i <= n; i ++) {
        ret = (ret + dp[m][i]) % mod;
    }
    return ret;
}

void init() {
    comb[0][0] = 1;
    for(ll i = 1; i < MAX_N; i ++) {
        for(ll j = 1; j < MAX_N; j ++) {
            comb[i][j] = (comb[i - 1][j] + comb[i - 1][j - 1]) % mod;
        }
        comb[i][0] = 1;
    }
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cerr.tie(NULL);
#endif // LOCAL

    cin >> n >> m >> mod;

    init();

    for(ll i = 0; i < n; i ++) {
        string s;
        cin >> s;
        for(ll j = 0; j < m; j ++) {
            ok[i][j] = (s[j] == '1');
        }
    }

    for(ll i = 0; i < n; i ++) {
        cout << solve(i) << endl;
    }

    return 0;
}

/*
15 10 13
1100001000
1000001110
1011111011
1010110001
1000111110
1100000111
1000100110
1011010110
1001101011
1110011001
1001111011
1001110001
0100111000
1110010000
0001010100
*/
