#include "minimize.h"
#include <bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=1e5+6;
const ll MAXK=22;
const ll INF=2e18;
ll x[MAXN];
ll dp[MAXN][MAXK];
int n,k;
void initialize(int N,int K,vector<int>a)
{
    n=N;k=K;
    for(int i=0;i<a.size();i++)x[i+1]=a[i];
}
void modify(int pos,int val)
{
    x[pos+1]=val;
}
ll calculate()
{
    for(int j=0;j<=k;j++)
    {
        dp[0][j]=0;
    }
    for(int i=1;i<=n+1;i++)
    {
        for(int j=0;j<=k;j++)
        {
            dp[i][j]=dp[i-1][j];
            if(i!=1&&i!=n+1)dp[i][j]+=x[i]^x[i-1];
        }
        for(int state=1;state<=k;state++)
        {
            for(int use=1;use<=state;use++)
            {
                if(i<=n)
                {
                    if(i-use-1>0)dp[i][state]=min(dp[i][state],dp[i-use-1][state-use]+x[i]+x[i-use-1]-2*(x[i]&x[i-use-1]));
                    else dp[i][state]=min(dp[i][state],0ll);
                }
                else
                {
                    if(i-use-1<=0)dp[i][state]=min(dp[i][state],0ll);
                    else dp[i][state]=min(dp[i][state],dp[i-use-1][state-use]);
                }
            }
        }
        /*for(int j=0;j<=k;j++)
        {
            cout<<i<<" "<<j<<" "<<dp[i][j]<<endl;
        }*/
    }
    ll ans=INF;
    for(int i=0;i<=k;i++)ans=min(ans,dp[n+1][i]);
    return ans;
}
