#include <bits/stdc++.h>
using namespace std;

const int maxn = 4003, maxm = 1003;
int n, m;
string a [maxn];
int cnt [maxn][maxm];
long long dp [maxm][maxn];
long long mod;
long long comb [maxn][maxn];

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m >> mod;
    for (int i = 0; i < n; i ++) cin >> a [i];
    comb [0][0] = 1;
    for (int i = 1; i <= n; i ++){
        comb [i][0] = 1;
        for (int j = 1; j <= i; j ++) comb [i][j] = (comb [i - 1][j - 1] + comb [i - 1][j]) % mod;
    }

    for (int i = 0; i < n; i ++){
        for (int j = 0; j < n; j ++){
            for (int k = 0; k <= m; k ++){
                if (k == m || a [i][k] != a [j][k]){
                    cnt [i][k] ++;
                    break;
                }
            }
        }
        for (int j = 1; j <= n; j ++) dp [m][j] = comb [cnt [i][m] - 1][j - 1];
        for (int j = m - 1; j >= 0; j --){
            for (int k = 1; k <= n; k ++){
                dp [j][k] = 0;
                int maxl = k / 2;
                if (k % 2 == 0 && a [i][j] == '0') maxl --;
                maxl = min (maxl, cnt [i][j]);
                for (int l = 0; l <= maxl; l ++) dp [j][k] = (dp [j][k] + comb [cnt [i][j]][l] * dp [j + 1][k - l]) % mod;
            }
        }
        long long ans = 0;
        for (int j = 1; j <= n; j ++) ans = (ans + dp [0][j]) % mod;
        cout << ans << ' ';
    }
    cout << '\n';

}
