# include <bits/stdc++.h>
using namespace std;
long long MOD;
long long n,m;
const long long maxn = 4005;
string s[maxn],p[maxn];
map <string, vector <long long> > mp;
long long dp[maxn][1005];
long long fact[maxn], revfact[maxn];
long long fastpow(long long A, long long p)
{
    long long i;
    long long curr=A;
    A = 1;
    for(i =0; (1<<i)<=p; i ++)
    {
        if((1<<i)&p)
        {
            A = (A*curr)%MOD;
        }
        curr = (curr*curr)%MOD;
    }
    return A;
}
void makefact()
{
    long long i;
    fact[0] = 1;
    revfact[0]= fastpow(1,MOD-2);
    for(i = 1; i <= n; i++)
    {
        fact[i] = (fact[i-1]*i)%MOD;
        revfact[i] = fastpow(fact[i],MOD-2);
    }

}
long long comb(long long k, long long n)
{
    long long ans = (((fact[n]*revfact[k])%MOD)*revfact[n-k])%MOD;
    // cout<<"Comb "<<k<<" "<<n<<" "<<ans<<" ::: "<<fact[n]<<" "<<revfact[k]<<" "<<revfact[n-k]<<endl;
    return ans;
}
long long diffpos[maxn];
long long coef[maxn];
long long ANS[maxn];
long long as[maxn];
long long cf[maxn][maxn];
void solve_reversed(long long from, long long to, long long pos, int idx)
{
   // cout<<from<<" "<<to<<" "<<pos<<" : "<<endl;
    //for(auto u: coef)
    //    cout<<u<<" ";
   // cout<<endl;
    long long f;
    if(from>to)return ;
    if(from == to || pos == m)
    {
        long long x=0;

        long long num = to-from+1;
        for(int i = 1;i<=num;i++)
        {
            as[i] = (cf[idx][i]*comb(i-1,num-1))%MOD;
            x = (x + as[i])%MOD;
        }
         for(auto v: mp[s[from]])
        {
            ANS[v] = x;
        }
        return ;
    }
    for(f = from; f <= to; f++)
    {
        if(s[f][pos]=='1')break;
    }
    long long i,j;
    long long zeroes = f-from;
    long long ones = to-f+1;
    //cout<<zeroes<<" vs "<<ones<<endl;
   idx++;
    for(i = 1; i <= zeroes; i++)
    {
        for(j = 0; j <= min(ones,i-1); j++)
        cf[idx][i] = (cf[idx][i]+(cf[idx-1][i+j]*comb(j,ones))%MOD)%MOD;
    }
    solve_reversed(from,f-1,pos+1,idx);
    for(i = 0;i<=zeroes;i++)
        cf[idx][i] = 0;

    for(i = 1; i <= ones; i++)
    {
        for(j = 0; j <= min(zeroes,i); j++)
        cf[idx][i] = (cf[idx][i]+(cf[idx-1][i+j]*comb(j,zeroes))%MOD)%MOD;
    }  solve_reversed(f,to,pos+1,idx);
    for(i = 0;i<=ones;i++)
        cf[idx][i] = 0;

}
long long solvefor(long long v)
{
    //cout<<"************"<<s[v]<<endl;
    long long uk1 = v,uk2 = v;
    long long i,j;
    for(i =0; i <= n; i++)
        for(j = 0; j <= m; j++)
            dp[i][j] = 0;
    while(uk1 > 1 && s[uk1-1]==s[v])uk1--;
    while(uk2 < n && s[uk2+1]==s[v])uk2++;
    for(i = 1; i <= uk2-uk1+1; i++)
    {

        dp[i][m] = comb(i-1,(uk2-uk1)); //cout<<i<<" "<<m<<" --> "<<dp[i][m]<<endl;
    }
    long long from = uk1;
    long long to = uk2;
    for(long long t = m-1; t >= 0; t--)
    {
        long long pos = t;
        long long prevbr = uk2-uk1+1;
        long long currbr = 0;
        if(s[v][pos]=='0')
        {

            while(uk2<n &&  diffpos[uk2+1]>=pos)
            {
                uk2++;
                currbr++;
            }
        }
        else
        {
            while(uk1>1 && diffpos[uk1]>=pos)
            {
                uk1--;
                currbr++;
            }
        }

        // cout<<"NOW: "<<t<<" "<<prevbr<<" "<<currbr<<endl;
        for(i = 1; i <=prevbr; i++)
        {
            //  cout<<v<<" :: "<<t+1<<" "<<i<<" "<<dp[i][t+1]<<endl;
            //  cout<< (min(i,currbr) - (s[v][pos]=='1' ? 0 : 1))<<" -------------"<<endl;
            for(j = 0; j <= (min((i- (s[v][pos]=='1' ? 0 : 1)),currbr) ); j++)
            {
                //  cout<<i<<"   "<<j<<" :: "<<t<<endl;
                dp[i+j][t] =( dp[i+j][t] + (dp[i][t+1]*comb(j,currbr))%MOD ) %MOD;
            }
        }
        while(from > 1 && diffpos[from] >= pos)
            from--;
        while(to < n && diffpos[to+1]>=pos)to++;
        uk1 = from;
        uk2 = to;
        //  cout<<from<<" <->"<<to<<endl;
    }
    long long ans = 0;
    for(i = 1; i<=n; i++)
    {
        ans = (ans + dp[i][0])%MOD;
        //  cout<<"FINAL : "<<i<<" "<<dp[i][0]<<endl;
    }

    return ans;
}


int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m>>MOD;
    long long i,j;
    for(i = 1; i<=n; i++)
    {
        cin>>s[i];
        mp[s[i]].push_back(i);
    }
    makefact();
    sort(s+1,s+n+1);
   /* for(i = 2; i<=n; i++)
    {
        for(j = 0; j <m; j++)
            if(s[i][j]!=s[i-1][j])break;
        diffpos[i] = j;
    }*/
    /*for(i = 1; i <= n; i++)
    {
        if(i>1 && s[i]==s[i-1])continue;
        long long x = solvefor(i);
        for(auto v: mp[s[i]])
        {
            ANS[v] = x;
        }
    }*/

    for(i= 0;i<=n;i++)cf[0][i] = 1;
    solve_reversed(1,n,0,0);
    for(i = 1; i <= n; i++)
        cout<<ANS[i]<<" ";
    cout<<endl;
}
/*
4 3 11
011
001
101
111
*/
/*
6 3 97
011
010
000
111
110
100
*/
