#include<iostream>
#include<unordered_map>
#define MAXT 4000007
#define MAXN 4007
using namespace std;

struct node{
    int ch[2];
    int sz,ps;
};

int hesh(int n,int k){
    return n*10000+k;
}

node trie[MAXT];
int n,m,num,curr,tim,id;
long long mod,ans;
string s[MAXN];

void add(string s){
    curr=1; trie[curr].sz++;
    for(int i=0;i<s.size();i++){
        if(trie[curr].ch[s[i]-'0']==0){
            num++; trie[curr].ch[s[i]-'0']=num;
        }
        curr=trie[curr].ch[s[i]-'0'];
        trie[curr].sz++; trie[curr].ps=i+1;
    }
}

int li[4007*1007];

void dfs(string s){
    curr=1; li[1]=tim;
    for(int i=0;i<s.size();i++){
        curr=trie[curr].ch[s[i]-'0'];
        li[curr]=tim;
    }
}

long long c[4007][4007];
unordered_map<int,long long> dp;

void prnt(int x){
    if(x==0)return;
    cout<<"start of "<<x<<"\n";
    cout<<"zero:\n";
    prnt(trie[x].ch[0]);
    cout<<"one:\n";
    prnt(trie[x].ch[1]);
    cout<<"end of "<<x<<"\n";
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>mod; num=1;
    for(int i=1;i<=n;i++){
        cin>>s[i];
        add(s[i]);
    }
    //prnt(1);
    for(int i=0;i<=n;i++){
        c[0][i]=1;
    }
    for(int i=1;i<=n;i++){
        for(int f=i;f<=n;f++){
            c[i][f]=(c[i-1][f-1]+c[i][f-1])%mod;
        }
    }

    for(int i=1;i<=n;i++){
        tim++; id=i; ans=0; dfs(s[i]);
        for(int f=num;f>=1;f--){
            if(li[f]!=tim)continue;
            for(int p=1;p<=n;p++){
                dp[hesh(f,p)]=0;
                if(p>trie[f].sz)continue;
                if(trie[f].ch[0]==0 and trie[f].ch[1]==0)dp[hesh(f,p)]=c[p-1][trie[f].sz-1];
                else{
                   if(s[id][trie[f].ps]=='0'){
                        for(int i=p/2+1;i<=min(trie[trie[f].ch[0]].sz,p);i++){
                            dp[hesh(f,p)]+=dp[hesh(trie[f].ch[0],i)] * c[p-i][trie[trie[f].ch[1]].sz];
                            dp[hesh(f,p)]%=mod;
                        }
                    }else{
                        for(int i=p/2+p%2;i<=min(trie[trie[f].ch[1]].sz,p);i++){
                            dp[hesh(f,p)]+=c[p-i][trie[trie[f].ch[0]].sz] * dp[hesh(trie[f].ch[1],i)];
                            dp[hesh(f,p)]%=mod;
                        }
                    }
                }
            }
        }
        for(int f=1;f<=n;f++){
            ans+=dp[hesh(1,f)];
            ans%=mod;
        }
        cout<<ans<<" ";
    }
    cout<<"\n";

    return 0;
}

/**
5 5 100
10010
00110
11000
01010
11001


*/
