#include<iostream>
#include<unordered_map>
#define MAXT 4000007
#define MAXN 4007
#define LL __int128
using namespace std;

struct node{
    int ch[2];
    int sz,ps;
};

inline int hesh(int &n,int &k){
    return n*10000+k;
}

node trie[MAXT];
int n,m,num,curr,tim,id;
long long mod,ans;
string s[MAXN];

void add(string s){
    curr=1; trie[curr].sz++;
    for(int i=0;i<s.size();i++){
        if(trie[curr].ch[s[i]-'0']==0){
            num++; trie[curr].ch[s[i]-'0']=num;
        }
        curr=trie[curr].ch[s[i]-'0'];
        trie[curr].sz++; trie[curr].ps=i+1;
    }
}

long long c[4007][4007];
unordered_map<int,LL> dp,li;
LL dp2[10007][4007];
int li2[10007][4007];

LL ff(int n,int k){
    if(trie[n].ch[0]==0 and trie[n].ch[1]==0)return c[k-1][trie[n].sz-1];

    if(li[hesh(n,k)]==tim)return dp[hesh(n,k)];
    li[hesh(n,k)]=tim;
    dp[hesh(n,k)]=0;

    if(s[id][trie[n].ps]=='0'){
        for(int i=max(k/2+1,k-trie[trie[n].ch[1]].sz);i<=min(trie[trie[n].ch[0]].sz,k);i++){
            dp[hesh(n,k)]+=ff(trie[n].ch[0],i) * c[k-i][trie[trie[n].ch[1]].sz];
        }
    }else{
        for(int i=max(k/2+k%2,k-trie[trie[n].ch[0]].sz);i<=min(trie[trie[n].ch[1]].sz,k);i++){
            dp[hesh(n,k)]+=c[k-i][trie[trie[n].ch[0]].sz] * ff(trie[n].ch[1],i);
        }
    }

    dp[hesh(n,k)]%=mod;
    return dp[hesh(n,k)];
}

LL ff2(int n,int k){
    if(trie[n].ch[0]==0 and trie[n].ch[1]==0)return c[k-1][trie[n].sz-1];

    if(li2[n][k]==tim)return dp2[n][k];
    li2[n][k]=tim;
    dp2[n][k]=0;

    if(s[id][trie[n].ps]=='0'){
        for(int i=max(k/2+1,k-trie[trie[n].ch[1]].sz);i<=min(trie[trie[n].ch[0]].sz,k);i++){
            dp2[n][k]+=ff2(trie[n].ch[0],i) * c[k-i][trie[trie[n].ch[1]].sz];
        }
    }else{
        for(int i=max(k/2+k%2,k-trie[trie[n].ch[0]].sz);i<=min(trie[trie[n].ch[1]].sz,k);i++){
            dp2[n][k]+=c[k-i][trie[trie[n].ch[0]].sz] * ff2(trie[n].ch[1],i);
        }
    }

    dp2[n][k]%=mod;
    return dp2[n][k];
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>mod; num=1;
    for(int i=1;i<=n;i++){
        cin>>s[i];
        add(s[i]);
    }
    //prnt(1);
    for(int i=0;i<=n;i++){
        c[0][i]=1;
    }
    for(int i=1;i<=n;i++){
        for(int f=i;f<=n;f++){
            c[i][f]=(c[i-1][f-1]+c[i][f-1])%mod;
        }
    }

    for(int i=1;i<=n;i++){
        tim++; id=i; ans=0;
        for(int f=1;f<=n;f++){
            if(num>10000)ans+=ff(1,f);
            else ans+=ff2(1,f);
            ans%=mod;
        }
        cout<<ans<<" ";
    }
    cout<<"\n";

    return 0;
}



/**
5 5 100
10010
00110
11000
01010
11001
for(int i=max(k/2+1,k-trie[trie[n].ch[1]].sz);i<=min(trie[trie[n].ch[0]].sz,k);i++){

    for(int i=max(k/2+k%2,k-trie[trie[n].ch[0]].sz);i<=min(trie[trie[n].ch[1]].sz,k);i++){

*/
