#include "minimize.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;
const int MAXK = 20;
const long long INF = 1e18 + 1;

int n, k, mn;
vector<int> v;
long long dp[MAXN + 5][MAXK + 5][MAXK + 5]; /// dp[where][how many changed][how many consecutive]

void initialize(int N, int K, vector<int> a)
{
    n = N; k = K; v = a;
}

void modify(int pos, int val)
{
    v[pos] = val;
    mn = min(mn, pos);
}

long long calculate()
{
    if (mn == n) mn = 1;
    for (int i = mn; i < n; ++ i)
    {
        for (int j = 0; j <= k; ++ j)
        {
            for (int t = 0; t <= k; ++ t)
            {
                dp[i][j][t] = -1;
            }
        }
    }

    long long ret = INF;
    dp[0][0][0] = dp[0][1][1] = 0;
    for (int i = mn; i < n; ++ i)
    {
        for (int j = 0; j <= k; ++ j)
        {
            for (int t = 0; t <= j; ++ t)
            {
                if (dp[i - 1][j][t] == -1) continue;
                dp[i][j][0] = min((dp[i][j][0] == -1 ? INF : dp[i][j][0]), dp[i - 1][j][t] + (i == t ? 0 : (v[i - 1 - t] ^ v[i])));
                if (i == n - 1) ret = min(ret, dp[i][j][0]);
                if (j + 1 <= k)
                {
                    dp[i][j + 1][t + 1] = dp[i - 1][j][t];
                    if (i == n - 1) ret = min(ret, dp[i][j + 1][t + 1]);
                }
            }
        }
    }
    mn = n;
    return ret;
}
