#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
const int maxn = 4010, maxm = 4010;
typedef long long ll;
const ll hash_mod = 1e9 + 7, mod_base = 27;
int n, m;
ll mod;
string s[maxn];
ll hs[maxn][maxm];
unordered_map < ll, ll > dp[maxn];
struct need_hash
{
    ll cur_hash, bef_hash;
    char c;

    bool operator < (const need_hash &nh) const
    {
        return cur_hash < nh.cur_hash;
    }
};
vector < need_hash > v[maxm];
unordered_map < ll, int > occ;
ll power(ll base, ll st)
{
    ll ans = 1;
    while(st > 0)
    {
        if (st % 2)
            ans = (ans * base) % mod;
        base = (base * base) % mod;
        st /= 2;
    }

    return ans;
}

ll C[maxn][maxn];
void precalc_choose()
{
    for (int i = 0; i <= n; i ++)
        C[i][0] = 1;

    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
        C[i][j] = (C[i - 1][j - 1] + C[i - 1][j]) % mod;
}

void solve()
{
    cin >> n >> m >> mod;
    precalc_choose();
    for (int i = 0; i < n; i ++)
    {
        ///for (int j = 0; j < m; j ++)
         ///   s[i] = s[i] + '0';
      cin >> s[i];
    }

    for (int i = 0; i < n; i ++)
    {
        hs[i][0] = (s[i][0] - '0' + 1);
        occ[hs[i][0]] ++;
        for (int j = 1; j < m; j ++)
    {
        hs[i][j] = (hs[i][j - 1] * mod_base + s[i][j] - '0' + 1);
        need_hash nh;
        nh.cur_hash = hs[i][j];
        nh.bef_hash = hs[i][j - 1];
        nh.c = s[i][j];
        v[j + 1].push_back(nh);
        occ[hs[i][j]] ++;
    }

    /**for (int j = 0; j < m; j ++)
    {
        v[j + 1].push_back({hs[i][j], s[i][j]});
        occ[hs[i][j]] ++;
    }*/

        ///v[j + 1].push_back(s[i].substr(0, j + 1));
        ///occ[s[i].substr(0, j + 1)] ++;
    }




    int start0 = 0, start1 = 0;
    for (int i = 0; i < n; i ++)
    {
        if (s[i][0] == '1')
            start1 ++;
        else
            start0 ++;
    }

    ll sum = 0;
    for (int i = 0; i <= n; i ++)
    {
        sum = (sum + C[start0][i]) % mod;
        dp[i][2] = sum;
    }

    sum = 0;
    for (int i = 0; i <= n; i ++)
    {
        sum = (sum + C[start1][i]) % mod;
        dp[i + 1][1] = sum;
    }

    /**for (int i = 0; i < n; i ++, cout << endl)
        for (int j = 0; j < m; j ++)
        cout << hs[i][j] << " ";*/

    for (int len = 2; len <= m; len ++)
    {
        sort(v[len].begin(), v[len].end());
        for (int i = 0; i < v[len].size(); i ++)
        {
            if (i != 0 && v[len][i].cur_hash == v[len][i - 1].cur_hash)
                continue;
            ll cur = v[len][i].cur_hash;
            if (v[len][i].c == '1')
            {
                ///cout << "here" << endl;
                ll rev = v[len][i].bef_hash, rem = v[len][i].bef_hash;
                rev = (rev * mod_base + 1);
                             ///cout << cur << " " << rev << " " << rem << endl;
                ll sum = 0, tp = occ[cur];
                for (int j = 1; j <= tp; j ++)
                {
                    for (int bk = 0; bk <= min(occ[rev], j); bk ++)
                    {
                        dp[j][cur] = (dp[j][cur] + (dp[j + bk][rem] * C[occ[rev]][bk]) % mod) % mod;
                    }
                }
            }
            else
            {
                ll rev = v[len][i].bef_hash, rem = v[len][i].bef_hash;
                rev = (rev * mod_base + 2);
                ll sum = 0, tp = occ[cur];
                for (int j = 1; j <= tp; j ++)
                {

                    //cout << occ[rev] << " " << j << " " << C[occ[rev]][j] << endl;
                    for (int bk = 0; bk <= min(occ[rev], j - 1); bk ++)
                    {
                        dp[j][cur] = (dp[j][cur] + (dp[j + bk][rem] * C[occ[rev]][bk]) % mod) % mod;
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; i ++)
    {
        ///cout << i << " " << dp[2][s[i]] << endl;
        ll ans = 0;
        for (int j = 1; j <= n; j ++)
        {
            ans = (ans + (dp[j][hs[i][m - 1]] * C[occ[hs[i][m - 1]] - 1][j - 1]) % mod) % mod;
        }
        cout << ans << " ";
    }
    cout << endl;


}
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
int main()
{
    speed();
    solve();
    return 0;
}
