#include "minimize.h"

#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
const int maxn = 1e5 + 10, maxk = 21;
const ll inf = 1e17;

int n, k, a[maxn];
ll dp[maxn][maxk];
void initialize(int _N, int _K, vector < int > _a)
{
    n = _N;
    k = _K;
    for (int i = 0; i < n; i ++)
        a[i] = _a[i];
}

void modify(int pos, int val)
{
    a[pos] = val;
}

long long calculate()
{
    for (int i = 0; i <= n; i ++)
    {
        for (int j = 0; j <= k; j ++)
            dp[i][j] = inf;
    }


    dp[0][0] = 0;

    for (int i = 1; i < n; i ++)
    {
        if (i <= k)
            dp[i][i] = 0;

        for (int p = 0; p <= k; p ++)
        {
        for (int j = max(0, i - p - 1); j < i; j ++)
        {
            ll to_add = 0;

                to_add = (a[i] ^ a[j]);
            /**for (int bit = 0; bit < 31; bit ++)
            {
                int tf1 = (a[j] & (1 << bit));
                int tf2 = (a[i] & (1 << bit));
                if (tf1 != tf2)
                    to_add += (ll(1) << bit);
            }*/

            ///cout << i << " " << p << " " << j << " " << to_add << " " << dp[i][p] << " " << p - (i - j - 1) << " " << dp[j][p - (i - j - 1)] << endl;
            dp[i][p] = min(dp[i][p], dp[j][p - (i - j - 1)] + to_add);
        }
        }
    }
    for (int p = 0; p <= k; p ++)
    for (int i = max(0, n - p - 1); i < n;  i ++)
        dp[n][p] = min(dp[n][p], dp[i][p - (n - i - 1)]);
    /**for (int i = 0; i <= n; i ++, cout << endl)
        for (int j = 0; j <= k; j ++)
        cout << dp[i][j] << " ";*/
    ll ans = inf;
    /**for (int j = 0; j <= k; j ++)
        ans = min(ans, dp[n][j]);
    cout << "here " << ans << endl;*/
    return ans;

}
