#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
ll mod = 1e9 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const int MAX_N = 4e3 + 10;
bool on[MAX_N][MAX_N];
int n, m;
int ans[MAX_N];

void recurse(int x, int mask) {
    if(x == m) {
        for(int i = 0; i < n; i ++) {
            if((1 << i)& mask) {
                ans[i] ++;
            }
        }
        return;
    }

    int cnt[2] = {0, 0};
    for(int i = 0; i < n; i ++) {
        if((1 << i) & mask) {
            cnt[on[i][x]] ++;
        }
    }

    if(cnt[1] >= cnt[0]) {
        for(int i = 0; i < n; i ++) {
            if((1 << i) & mask) {
                if(!on[i][x]) {
                    mask -= (1 << i);
                }
            }
        }
    } else {
        for(int i = 0; i < n; i ++) {
            if((1 << i) & mask) {
                if(on[i][x]) {
                    mask -= (1 << i);
                }
            }
        }
    }

    recurse(x + 1, mask);
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> m >> mod;

    assert(n < 10);

    for(ll i = 0; i < n; i ++) {
        string s;
        cin >> s;
        for(ll j = 0; j < m; j ++) {
            on[i][j] = (s[j] == '1');
        }
    }

    for(int i = 0; i < (1 << n); i ++) {
        recurse(0, i);
    }

    for(int i = 0; i < n; i ++) {
        cout << ans[i] % mod << " ";
    }
    cout << endl;

    return 0;
}


