#include <bits/stdc++.h>
using namespace std;

#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL
#define endl "\n"

#define out(x) "[ " << #x << " : " << x << " ]"

template<class T, class T2> inline bool chkmax(T &x, const T2 &y) { return (x < y) ? x = y, 1: 0; }
template<class T, class T2> inline bool chkmin(T &x, const T2 &y) { return (x > y) ? x = y, 1: 0; }

typedef long long ll;
const ll mod = 1e18 + 7;
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

const ll MAX_N = 1e5 + 10, MAX_K = 21;
ll n, k;
vector<ll> arr;

void initialize(int N, int K, std::vector <int> a) {
    n = N;
    k = K;
    for(auto it : a) {
        arr.push_back(it);
    }
}

void modify(int pos, int val) {
    arr[pos] = val;
}

ll dp[MAX_N][MAX_K];

long long calculate() {
    for(ll i = 0; i < n; i ++) {
        for(ll j = 0; j <= k; j ++) {
            dp[i][j] = mod;
        }
    }
    for(ll i = 0; i <= k && i + 1 < n; i ++) {
        dp[i][i] = 0;
    }

    for(ll i = 0; i < n; i ++) {
        for(ll j = 0; j <= k && i - 1 - j >= 0; j ++) {
            for(ll l = 0; l + j <= k; l ++) {
                chkmin(dp[i][j + l], dp[i - 1 - j][l] + (arr[i - 1 - j] ^ arr[i]));
            }
        }
    }

    ll ret = mod;
    for(ll i = 0; i <= k; i ++) {
        chkmin(ret, dp[n - 1 - i][k - i]);
    }
    return ret;
}

/*
5 2
1 9 4 6 2
4
0
1 1 3
1 2 3
0
*/
