#include "minimize.h"
#include<bits/stdc++.h>
using namespace std;

const int nmax=1e5+42;

int SZ,ignore,inp[nmax];

void initialize(int n, int k, std::vector <int> a)
{
    SZ=n;
    ignore=k;
    for(int i=0;i<n;i++)inp[i]=a[i];
}
void modify(int pos, int val)
{
    inp[pos]=val;
}

long long dp[nmax][25];

long long rec(int pos,int to_skip)
{
    //cout<<"rec "<<pos<<" "<<to_skip<<endl;

    if(to_skip>=pos)return 0;

    if(dp[pos][to_skip]!=-1)return dp[pos][to_skip];

    long long ret=1e18;

    for(int j=pos-1;j>=0&&(pos-1-j)<=to_skip;j--)
        ret=min(ret,rec(j,to_skip-(pos-1-j))+(inp[j]^inp[pos]));

    dp[pos][to_skip]=ret;
    return ret;
}

long long calculate()
{
    for(int i=0;i<=SZ;i++)
        for(int j=0;j<=ignore;j++)
            dp[i][j]=-1;

    long long ret=1e18;
    for(int i=SZ-1;i>=0&&(SZ-1-i)<=ignore;i--)
        ret=min(ret,rec(i,ignore-(SZ-1-i)));

    return ret;
}

/*
int main() {
  std::cin.tie(NULL);
  std::ios_base::sync_with_stdio(false);

  // Note that every vector is 1 indexed

  int n, k;
  std::cin >> n >> k;
  std::vector <int> a(n, 0);
  for (int i = 0; i < n ; ++i)
    std::cin >> a[i];

  initialize(n, k, a);

  int q;
  std::cin >> q;


  std::vector <long long> ans;
  for (; q > 0 ; --q) {
    int type;
    std::cin >> type;
    if (type == 1) {
      // update nr positions
      int pos, val;
      std::cin >> pos >> val;

      if (pos < 0 || pos >= n) {
        std::cerr << "BAD UPDATE INDEX" << std::endl;
        exit(1);
      }

      modify(pos, val);
    } else if (type == 0) {
      // query
      cout<<"calculate= "<<calculate()<<endl;
      //ans.push_back(calculate());
    } else {
      // bad operation type
      std::cerr << "BAD OPERATION TYPE" << std::endl;
      exit(1);
    }
  }

  return 0;
}
*/
  /*
    0 - query
    1 - update

    update structure:
    1 pos val
  */
