#include<bits/stdc++.h>
#define endl '\n'

using namespace std;


long long mod;
long long comb[205][205];
long long prcomb[205][205];
long long st2[205];

void sv()
{
    comb[0][0]=1;
    st2[0]=1;
    for(int i=1; i<=200; i++)
    {
        st2[i]=2*st2[i-1];
        if(st2[i]>=mod) st2[i]-=mod;
        comb[i][0]=1;
        prcomb[i][0]=1;
        for(int j=1; j<=i; j++)
        {
            comb[i][j]=comb[i-1][j-1]+comb[i-1][j];
            if(comb[i][j]>=mod) comb[i][j]-=mod;
            prcomb[i][j]=prcomb[i][j-1]+comb[i][j];
            if(prcomb[i][j]>=mod) prcomb[i][j]-=mod;
        }
    }
    /**
    for(int i=0; i<=20; i++)
    {
        for(int j=0; j<=i; j++) cout<<comb[i][j]<<" ";
        cout<<endl;
    }*/
}


struct vote
{
    string s;
    int nom;
    long long ans;
    vote() {}
};

bool cmp1(vote p, vote q)
{
    return p.s<q.s;
}

bool cmp2(vote p, vote q)
{
    return p.nom<q.nom;
}

int n, m;
vote t[4005];
long long edn[205][205][2];
long long dp[205][205][205];

void solve(int le, int ri, int pos)
{
    if(le>ri) return;
    if(pos>=m) return;
    int br0=0, br1=0;
    for(int i=le; i<=ri; i++)
    {
        if(t[i].s[pos]=='0') br0++;
        else br1++;
    }
    for(int i=le; i<=ri; i++)
    {
        edn[i][pos][0]=br1;
        edn[i][pos][1]=br0;
        if(i<=le+br0-1) swap(edn[i][pos][0], edn[i][pos][1]);
    }
    solve(le, le+br0-1, pos+1);
    solve(le+br0, ri, pos+1);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>mod;
    sv();
    m++;
    for(int i=0; i<n; i++)
    {
        cin>>t[i].s;
        t[i].s="1"+t[i].s;
        t[i].nom=i;
        t[i].ans=0;
    }
    sort(t, t+n, cmp1);
    solve(0, n-1, 0);
    /**
    cout<<endl;
    for(int i=0; i<n; i++)
    {
        cout<<t[i].s<<endl;
    }
    cout<<endl;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<=m; j++) cout<<edn[i][j][0]<<" "<<edn[i][j][1]<<endl;
        cout<<endl;
    }*/
    int pos=m-1;
    for(int i=0; i<n; i++)
    {
        for(int j=1; j<=edn[i][pos][0]; j++)
        {
            if(t[i].s[m-1]=='1')
            {
                for(int k=0; k<=j; k++)
                {
                    dp[i][m-1][j+k]+=comb[edn[i][pos][0]-1][j-1]*comb[edn[i][pos][1]][k];
                    dp[i][m-1][j+k]%=mod;
                }
            }
            else
            {
                for(int k=0; k<j; k++)
                {
                    dp[i][m-1][j+k]+=comb[edn[i][pos][0]-1][j-1]*comb[edn[i][pos][1]][k];
                    dp[i][m-1][j+k]%=mod;
                }
            }
        }
    }
    for(pos=m-2; pos>=0; pos--)
    {

    for(int i=0; i<n; i++)
    {
        for(int j=1; j<=edn[i][pos][0]; j++)
        {
            if(t[i].s[pos]=='1')
            {
                for(int k=0; k<=j; k++)
                {
                    dp[i][pos][j+k]+=dp[i][pos+1][j]*comb[edn[i][pos][1]][k];
                    dp[i][pos][j+k]%=mod;
                }
            }
            else
            {
                for(int k=0; k<j; k++)
                {
                    dp[i][pos][j+k]+=dp[i][pos+1][j]*comb[edn[i][pos][1]][k];
                    dp[i][pos][j+k]%=mod;
                }
            }
        }
    }

    }
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<=n; j++)
        {
            t[i].ans+=dp[i][0][j];
            t[i].ans%=mod;
        }
    }
    sort(t, t+n, cmp2);
    for(int i=0; i<n; i++)
    {
        if(i) cout<<" ";
        cout<<t[i].ans;
    }
    cout<<endl;
    return 0;
}
