#include <bits/stdc++.h>
using namespace std;

const int maxn = 4003, maxm = 1003;
int n, m;
string a [maxn];
int cnt [maxn][maxm];
long long dp [maxm][maxn];
long long mod;
long long comb [maxn][maxn];

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m >> mod;
    for (int i = 0; i < n; i ++) cin >> a [i];
    comb [0][0] = 1;
    for (int i = 1; i <= n; i ++){
        comb [i][0] = 1;
        for (int j = 1; j <= i; j ++) comb [i][j] = (comb [i - 1][j - 1] + comb [i - 1][j]) % mod;
    }

    for (int i = 0; i < n; i ++){
        for (int j = 0; j < n; j ++){
            for (int k = 0; k <= m; k ++){
                if (k == m || a [i][k] != a [j][k]){
                    cnt [i][k] ++;
                    break;
                }
            }
        }
        for (int j = 0; j <= n; j ++) dp [0][j] = 0;
        for (int j = 0; j <= cnt [i][0]; j ++){
            int idx = max (1, j + '1' - a [i][0]);
            dp [0][idx] += comb [cnt [i][0]][j];
            dp [0][idx] %= mod;
        }
        for (int j = 1; j < m; j ++){
            for (int k = 0; k <= n; k ++) dp [j][k] = 0;
            for (int k = 0; k <= cnt [i][j]; k ++){
                for (int l = 0; l <= n; l ++){
                    int idx = max (l - k, k + '1' - a [i][j]);
                    dp [j][idx] += comb [cnt [i][j]][k] * dp [j - 1][l];
                    dp [j][idx] %= mod;
                }
            }
        }
        long long ans = 0;
        for (int j = 1; j <= cnt [i][m]; j ++){
            for (int k = 0; k <= j; k ++){
                ans += comb [cnt [i][m] - 1][j - 1] * dp [m - 1][k];
                ans %= mod;
            }
        }
        cout << ans << ' ';
    }
    cout << '\n';

}
