#include <bits/stdc++.h>
//#pragma GCC optimize ("O3")
#pragma GCC optimize ("unroll-loops")
using namespace std;

const int maxn = 4003, maxm = 1003;
int n, m;
pair <string, int> a [maxn];
int cnt [maxn][maxm];
long long dp [maxm][maxn];
long long mod;
long long comb [maxn][maxn];

long long ans [maxn];

int main (){

    ios::sync_with_stdio (false);
    cin.tie (0);

    cin >> n >> m >> mod;
    for (int i = 0; i < n; i ++){
        cin >> a [i].first;
        a [i].second = i;
    }
    sort (a, a + n);
    comb [0][0] = 1;
    for (int i = 1; i <= n; i ++){
        comb [i][0] = 1;
        for (int j = 1; j <= i; j ++){
            comb [i][j] = (comb [i - 1][j - 1] + comb [i - 1][j]);
            if (comb [i][j] >= mod) comb [i][j] -= mod;
        }
    }

    for (int i = 0; i < n; i ++){
        int pos = 0;
        for (int j = n - 1; j >= i; j --){
            while (pos < m && a [i].first [pos] == a [j].first [pos]) pos ++;
            cnt [i][pos] ++;
        }
        pos = 0;
        for (int j = 0; j < i; j ++){
            while (pos < m && a [i].first [pos] == a [j].first [pos]) pos ++;
            cnt [i][pos] ++;
        }
        if (pos == 0){
            for (int j = 0; j <= n; j ++) dp [0][j] = 0;
            for (int j = 0; j <= cnt [i][0]; j ++){
                int idx = max (1, j + '1' - a [i].first [0]);
                dp [0][idx] += comb [cnt [i][0]][j];
                if (dp [0][idx] >= mod) dp [0][idx] -= mod;
            }
            pos ++;
        }
        for (int j = pos; j < m; j ++){
            for (int k = 0; k <= n; k ++) dp [j][k] = 0;
            for (int k = 0; k <= cnt [i][j]; k ++){
                for (int l = 0; l <= n; l ++){
                    int idx = max (l - k, k + '1' - a [i].first [j]);
                    dp [j][idx] += comb [cnt [i][j]][k] * dp [j - 1][l];
                    dp [j][idx] %= mod;
                }
            }
        }
        long long x = dp [m - 1][0];
        for (int j = 1; j <= cnt [i][m]; j ++){
            x +=  dp [m - 1][j];
            if (x > mod) x -= mod;
            ans [a [i].second] += comb [cnt [i][m] - 1][j - 1] * x;
            ans [a [i].second] %= mod;
        }
    }

    for (int i = 0; i < n; i ++){
        cout << ans [i] << ' ';
    }
    cout << '\n';

}
