#include <bits/stdc++.h>
#include "minimize.h"
#include "Lgrader.cpp"
using namespace std;

const int maxn = 100005, maxk = 22;
int n, k;
int a [maxn];
long long dp [maxn][maxk];

void initialize(int _n, int _k, vector<int> _a){
    n = _n;
    k = _k;
    for (int i = 0; i < n; i ++) a [i] = _a [i];
}

void modify(int pos, int val){
    a [pos] = val;
}

long long calculate(){

    for (int i = 1; i < n; i ++){
        for (int j = 0; j <= k; j ++){
            if (i <= j){
                dp [i][j] = 0;
                continue;
            }
            dp [i][j] = dp [i - 1][j] + (a [i - 1] ^ a [i]);
            for (int h = 1; h <= j; h ++) dp [i][j] = min (dp [i][j], dp [i - 1 - h][j - h] + (a [i - 1 - h] ^ a [i]));
        }
    }
    for (int i = 0; i <= k; i ++){
        dp [n][i] = dp [n - 1][i];
        for (int j = 1; j <= i; j ++) dp [n][i] = min (dp [n][i], dp [n - 1 - j][i - j]);
    }
    return dp [n][k];

}
