# include <bits/stdc++.h>
using namespace std;
int MOD;
int n,m;
const int maxn = 4001;
string s[maxn],p[maxn];
map <string, vector <int> > mp;
long long dp[maxn][1005];
long long fact[maxn], revfact[maxn];
long long fastpow(long long A, long long p)
{
    int i;
    long long curr=A;
    A = 1;
    for(i =0; (1<<i)<=p; i ++)
    {
        if((1<<i)&p)
        {
            A = (A*curr)%MOD;
        }
        curr = (curr*curr)%MOD;
    }
    return A;
}
void makefact()
{
    int i;
    fact[0] = 1;
    revfact[0]= fastpow(1,MOD-2);
    for(i = 1; i <= n; i++)
    {
        fact[i] = (fact[i-1]*i)%MOD;
        revfact[i] = fastpow(fact[i],MOD-2);
    }

}
long long comb(int k, int n)
{
    long long ans = (((fact[n]*revfact[k])%MOD)*revfact[n-k])%MOD;
    // cout<<"Comb "<<k<<" "<<n<<" "<<ans<<" ::: "<<fact[n]<<" "<<revfact[k]<<" "<<revfact[n-k]<<endl;
    return ans;
}
int diffpos[maxn];
long long solvefor(int v)
{
    //cout<<"************"<<s[v]<<endl;
    int uk1 = v,uk2 = v;
    int i,j;
    for(i =0; i <= n; i++)
        for(j = 0; j <= m; j++)
            dp[i][j] = 0;
    while(uk1 > 1 && s[uk1-1]==s[v])uk1--;
    while(uk2 < n && s[uk2+1]==s[v])uk2++;
    for(i = 1; i <= uk2-uk1+1; i++)
    {

        dp[i][m] = comb(i-1,(uk2-uk1)); //cout<<i<<" "<<m<<" --> "<<dp[i][m]<<endl;
    }
    int from = uk1;
    int to = uk2;
    for(int t = m-1; t >= 0; t--)
    {
        int pos = t;
        int prevbr = uk2-uk1+1;
        int currbr = 0;
        if(s[v][pos]=='0')
        {

            while(uk2<n &&  diffpos[uk2+1]>=pos)
            {
                uk2++;
                currbr++;
            }
        }
        else
        {
            while(uk1>1 && diffpos[uk1]>=pos)
            {
                uk1--;
                currbr++;
            }
        }

        // cout<<"NOW: "<<t<<" "<<prevbr<<" "<<currbr<<endl;
        for(i = 1; i <=prevbr; i++)
        {
            //  cout<<v<<" :: "<<t+1<<" "<<i<<" "<<dp[i][t+1]<<endl;
            //  cout<< (min(i,currbr) - (s[v][pos]=='1' ? 0 : 1))<<" -------------"<<endl;
            for(j = 0; j <= (min((i- (s[v][pos]=='1' ? 0 : 1)),currbr) ); j++)
            {
                //  cout<<i<<"   "<<j<<" :: "<<t<<endl;
                dp[i+j][t] =( dp[i+j][t] + (dp[i][t+1]*comb(j,currbr))%MOD ) %MOD;
            }
        }
        while(from > 1 && diffpos[from] >= pos)
            from--;
        while(to < n && diffpos[to+1]>=pos)to++;
        uk1 = from;
        uk2 = to;
        //  cout<<from<<" <->"<<to<<endl;
    }
    long long ans = 0;
    for(i = 1; i<=n; i++)
    {
        ans = (ans + dp[i][0])%MOD;
        //  cout<<"FINAL : "<<i<<" "<<dp[i][0]<<endl;
    }

    return ans;
}
long long ANS[maxn];

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin>>n>>m>>MOD;
    int i,j;
    for(i = 1; i<=n; i++)
    {
        cin>>s[i];
        mp[s[i]].push_back(i);
    }
    makefact();
    sort(s+1,s+n+1);
    for(i = 2; i<=n; i++)
    {
        for(j = 0; j <m; j++)
            if(s[i][j]!=s[i-1][j])break;
        diffpos[i] = j;
    }
    for(i = 1; i <= n; i++)
    {
        long long x = solvefor(i);
        for(auto v: mp[s[i]])
        {
            ANS[v] = x;
        }
    }
    for(i = 1; i <= n; i++)
        cout<<ANS[i]<<" ";
    cout<<endl;
}
/*
4 3 11
011
001
101
111
*/
/*
6 3 97
011
010
000
111
110
100
*/
