#include <iostream>
#include <string>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200;

int n, m;
long long mod;
int cnt[MAXN + 5];
string s[MAXN + 5];

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m >> mod;

    for (int i = 0; i < n; ++ i)
    {
        cin >> s[i];
    }

    for (int mask = 1; mask < (1ll << n); ++ mask)
    {
        vector<int> active, temp;
        for (int i = 0; i < n; ++ i)
        {
            if (mask & (1ll << i)) active.push_back(i);
        }

        for (int pos = 0; pos < m; ++ pos)
        {
            int cnt1 = 0, cnt0 = 0;
            for (auto i : active)
            {
                if (s[i][pos] == '1') cnt1++;
                else cnt0++;
            }

            temp = {};

            if (cnt1 >= cnt0)
            {
                for (auto i : active)
                {
                    if (s[i][pos] == '1') temp.push_back(i);
                }
            }
            else
            {
                for (auto i : active)
                {
                    if (s[i][pos] == '0') temp.push_back(i);
                }
            }

            active = temp;
        }

        for (auto i : active)
        {
            cnt[i]++;
        }
    }

    for (int i = 0; i < n; ++ i)
    {
        cout << cnt[i] << " ";
    }
    cout << endl;

    return 0;
}
