#include "minimize.h"
#include "Lgrader.cpp"
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int n, k;
long long s;
vector<int> v;
int x[MAXN + 5];

void initialize(int N, int K, vector<int> a)
{
    n = N; k = K; v = a;
    for (int i = 0; i < n - 1; ++ i)
    {
        x[i] = (v[i] ^ v[i + 1]);
        s += x[i];
    }
}

void modify(int pos, int val)
{
    v[pos] = val;
}

long long calculate()
{
    long long mn = min(s - x[0], s - x[n - 1]);
    for (int i = 1; i < n - 1; ++ i)
    {
        mn = min(mn, s - x[i - 1] - x[i] + (v[i - 1] ^ v[i + 1]));
    }
    return mn;
}
