#include "minimize.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

int n, k;
vector<int> v;
long long s, x[MAXN + 5];

void initialize(int N, int K, vector<int> a)
{
    n = N; k = K; v = a;
    for (int i = 0; i < n - 1; ++ i)
    {
        x[i] = (v[i] ^ v[i + 1]);
        s += x[i];
    }
}

void modify(int pos, int val)
{
    if (pos == 0) s -= x[0];
    else if (pos == n - 1) s -= x[n - 2];
    else s -= x[pos - 1] + x[pos];
    v[pos] = val;
    if (pos == 0)
    {
        x[0] = (v[0] ^ v[1]);
        s += x[0];
    }
    else if (pos == n - 1)
    {
        x[n - 2] = (v[n - 2] ^ v[n - 1]);
        s += x[n - 2];
    }
    else
    {
        x[pos - 1] = (v[pos - 1] ^ v[pos]);
        x[pos] = (v[pos] ^ v[pos + 1]);
        s += x[pos - 1] + x[pos];
    }
}

long long calculate()
{
    long long mn = min(s - x[0], s - x[n - 1]);
    for (int i = 1; i < n - 1; ++ i)
    {
        mn = min(mn, s - x[i - 1] - x[i] + (v[i - 1] ^ v[i + 1]));
    }
    return mn;
}
