#include<bits/stdc++.h>

using namespace std;
typedef long long ll;
const int maxn = 210, maxm = 210;
typedef long long ll;

int n, m;
ll mod;
string s[maxn];
unordered_map < string, ll > dp[maxn];
vector < string > v[maxm];
unordered_map < string, int > occ;
ll power(ll base, ll st)
{
    ll ans = 1;
    while(st > 0)
    {
        if (st % 2)
            ans = (ans * base) % mod;
        base = (base * base) % mod;
        st /= 2;
    }

    return ans;
}

ll C[maxn][maxn];
void precalc_choose()
{
    for (int i = 0; i <= n; i ++)
        C[i][0] = 1;

    for (int i = 1; i <= n; i ++)
        for (int j = 1; j <= n; j ++)
        C[i][j] = (C[i - 1][j - 1] + C[i - 1][j]) % mod;
}

void solve()
{
    cin >> n >> m >> mod;
    precalc_choose();
    for (int i = 0; i < n; i ++)
        cin >> s[i];

    for (int i = 0; i < n; i ++)
        for (int j = 0; j < m; j ++)
    {
        v[j + 1].push_back(s[i].substr(0, j + 1));
        occ[s[i].substr(0, j + 1)] ++;
    }




    int start0 = 0, start1 = 0;
    for (int i = 0; i < n; i ++)
    {
        if (s[i][0] == '1')
            start1 ++;
        else
            start0 ++;
    }

    ll sum = 0;
    for (int i = 0; i <= n; i ++)
    {
        sum = (sum + C[start0][i]) % mod;
        dp[i]["1"] = sum;
    }

    sum = 0;
    for (int i = 0; i <= n; i ++)
    {
        sum = (sum + C[start1][i]) % mod;
        dp[i + 1]["0"] = sum;
    }

    for (int len = 2; len <= m; len ++)
    {
        sort(v[len].begin(), v[len].end());
        for (int i = 0; i < v[len].size(); i ++)
        {
            if (i != 0 && v[len][i] == v[len][i - 1])
                continue;
            string cur = v[len][i];
            if (cur.back() == '1')
            {
                string rev = cur, rem = cur;
                rev.back() = '0';
                rem.pop_back();
                ll sum = 0, tp = occ[cur];
                for (int j = 1; j <= tp; j ++)
                {
                    for (int bk = 0; bk <= j; bk ++)
                    {
                        dp[j][cur] = (dp[j][cur] + (dp[j + bk][rem] * C[occ[rev]][bk]) % mod) % mod;
                    }
                }
            }
            else
            {
                string rev = cur, rem = cur;
                rev.back() = '1';
                rem.pop_back();
                ll sum = 0, tp = occ[cur];
                for (int j = 1; j <= tp; j ++)
                {

                    for (int bk = 0; bk < j; bk ++)
                    {
                        dp[j][cur] = (dp[j][cur] + (dp[j + bk][rem] * C[occ[rev]][bk]) % mod) % mod;
                    }
                }
            }
        }
    }

    for (int i = 0; i < n; i ++)
    {
        ///cout << i << " " << dp[2][s[i]] << endl;
        ll ans = 0;
        for (int j = 1; j <= n; j ++)
        {
            ans = (ans + (dp[j][s[i]] * C[occ[s[i]] - 1][j - 1]) % mod) %mod;
        }
        cout << ans << " ";
    }
    cout << endl;


}
int main()
{
    solve();
    return 0;
}
